/*
	SICCT Network Protocol defines for CT-API 
*/

#ifndef SICCT_H_
#define SICCT_H_

/* IP Communication */
#define SICCT_PORT 		4742
#define SICCT_ENV_SIZE		10
#define SICCT_READ_TO		5000 		/* in milliseconds */		
#define SICCT_MESSAGE_TO	(5*60*1000)	/* in milliseconds */		

/* Byte Offsets SICCT Envelop */
#define	SICCT_ENV_MESSAGE_TYPE_OFF	0
#define	SICCT_ENV_SRC_OR_DEST_OFF	1
#define	SICCT_ENV_SEQ_OFF		3
#define SICCT_ENV_LEN_OFF		6
#define SICCT_ENV_CMD_OFF		10

/* Message Types */
#define SICCT_MTYPE_CCMD	0x6B
#define SICCT_MTYPE_RCMD	0x83
#define SICCT_MTYPE_EVENT	0x50

/* Sequence Numbers */
#define SICCT_MIN_CMD_SEQ	0x0
#define SICCT_MAX_CMD_SEQ	0xFCFF
#define SICCT_MIN_EVENT_SEQ	0xFD00
#define SICCT_MAX_EVENT_SEQ	0xFFFF

/* Event Objects */
#define SICCT_EVENT_ALIVE_DO		0x80
#define SICCT_EVENT_SIGN_OFF_DO		0x81
#define SICCT_EVENT_FU_ADD_DO		0x82
#define SICCT_EVENT_FU_REMOVE_DO	0x83
#define SICCT_EVENT_CARD_INSERT_DO	0x84
#define SICCT_EVENT_CARD_REMOVE_DO	0x85
#define SICCT_EVENT_PERROR_DO		0x86
#define SICCT_EVENT_KEY_DO		0x87

/* error codes for PERROR */
#define SICCT_PERROR_TO_ENV		0x00	/* Envelop Read Timeout */
#define SICCT_PERROR_TO_DATA		0x01	/* Data Read Timeout */
#define SICCT_PERROR_TYPE		0x10	/* Bad Type */ 
#define SICCT_PERROR_DEST		0x11	/* Bad Destination */ 
#define SICCT_PERROR_SEQ		0x12	/* Bad Sequence Number */
#define SICCT_MAX_ERRORS		5

#endif 
